#include <stdio.h>
#include <algorithm>

#define MAX_N 205
#define FIN "color.in"
#define FOUT "color.out"
#define MOD 666013
#define ll long long

int N, M, K, C, col[MAX_N], A[MAX_N][MAX_N], B[MAX_N][MAX_N], Res;

int pow(int a, int b, int mod)
{
    int t;

    if (!b) return 1;
    t = pow(a, b/2, mod);
    t = ((ll)t*t) % mod;
    if (b&1) t = ((ll)t*a) % mod;
    return t;
}

int gauss(int mod)
{
    int i, j, k, p, t;

    for (i = 0; i < N; ++i)
    {
        for (j = 0; j < M; ++j)
            B[i][j] = A[i][j]%mod;
        B[i][M] = (C%mod + mod - col[i]%mod) % mod;
    }

    for (p = k = 0; k < M; ++k)
    {
        for (i = p; i < N; ++i)
            if (B[i][k]) break;
        if (i == N) continue;
        for (j = 0; j <= M; ++j)
            std::swap(B[p][j], B[i][j]);
        for (i = p+1; i < N; ++i)
        {
            t = ((ll)B[i][k] * pow(B[p][k], mod-2, mod)) % mod;
            for (j = 0; j <= M; ++j)
                B[i][j] = (B[i][j] + mod - ((ll)B[p][j]*t)%mod) % mod;
        }
        ++p;
    }

    fprintf(stderr, ">> %d -> %d\n", mod, p);

    for (i = 0; i < N; ++i)
    {
        for (j = 0; j < M && !B[i][j]; ++j);
        if (j == M && B[i][M]) { fprintf(stderr, "Fara solutii!\n"); return 0; }
    }

    t = 1;
    mod %= MOD;
    for (i = 0; i < M-p; ++i)
        t = ((ll)t*mod)%MOD;
    return t;
}

int main(void)
{
    int i, j;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d %d %d", &N, &M, &K, &C), --C;
    for (i = 0; i < N; ++i)
        scanf("%d", col+i), --col[i];
    for (i = 0; i < M; ++i)
        for (j = 0; j < N; ++j)
            scanf("%d", A[j]+i);

    Res = 1;
    for (i = 2; i*i <= K; ++i)
    {
        if (K%i) continue;
        Res = ((ll)Res * gauss(i)) % MOD;
        K /= i;
    }
    if (K > 1)
        Res = ((ll)Res * gauss(K)) % MOD;
    printf("%d\n", Res);

    return 0;
}
