/*
Autor: Victor Rusu
Punctaj: 80
*/
#include <cstdio>
#include <cassert>
#include <algorithm>

using namespace std;

#define FIN "color.in"
#define FOUT "color.out"

#define MAX_N 205
#define LL long long

const int MOD = 666013;

LL N, M, K, C;
LL A0[MAX_N][MAX_N];
LL A[MAX_N][MAX_N];
LL B0[MAX_N];
LL B[MAX_N];

void read() {
    scanf("%d %d %d %d", &N, &M, &K, &C);
    for (int i = 1; i <= N; ++i)
        scanf("%d", &B0[i]);
    for (int i = 1; i <= M; ++i)
        for (int j = 1; j <= N; ++j)
            scanf("%d", &A0[i][j]);
}

int power(int x, int p, int modul) {
    if (!p) return 1;

    if (p & 1)
        return ((LL)x * power(x, p - 1, modul)) % modul;
    else {
        int tmp = power(x, p / 2, modul);
        return ((LL)tmp * tmp) % modul;
    }
}

LL gauss(int K) {
    LL ret = 1;

    for (int i = 1; i <= M; ++i)
        for (int j = 1; j <= N; ++j)
            A[i][j] = A0[j][i] % K;
    for (int i = 1; i <= N; ++i)
        B[i] = (C - B0[i] + K) % K;

    int ind = 1;
    for (int i = 1; i <= M; ++i) {
        int j;
        for (j = ind; j <= N; ++j)
            if (A[j][i]) break;
        for (int k = 1; k <= M; ++k)
            swap(A[ind][k], A[j][k]);
        swap(B[ind], B[j]);
        
        if (!A[ind][i]) {
            ret = (ret * K) % MOD;
            continue;
        }

        int inv = power(A[ind][i], K - 2, K);
        for (int k = 1; k <= M; ++k)
            A[ind][k] = ((LL)A[ind][k] * inv) % K;
        B[ind] = ((LL)B[ind] * inv) % K;

        for (j = ind + 1; j <= N; ++j)
            if (A[j][i]) {
                int nr = A[j][i];
                assert(nr >= 0);
                for (int k = 1; k <= M; ++k) {
                    A[j][k] = ((LL)A[j][k] - (LL)nr * (LL)A[ind][k]) % K;
                    if (A[j][k] < 0) A[j][k] += K;
                }
                B[j] = ((LL)B[j] - (LL)nr * (LL)B[ind]) % K;
                if (B[j] < 0) B[j] += K;
            }

        ++ind;
    }

    for (int i = ind + 1; i <= N; ++i)
    {
        for (int j = 1; j <= M; ++j)
            assert(A[i][j] == 0);

        if (B[i])
            return 0;
    }

    return ret;
}

void solve() {
    LL sol = 1;
    int tmp = K;
    for (int i = 2; (LL)i * i <= K; ++i)
        if (tmp % i == 0) {
            sol = (sol * gauss(i)) % MOD;
            tmp /= i;
        }
    if (tmp > 1)
        sol = (sol * gauss(tmp)) % MOD;

    printf("%d\n", sol);
}

int main() {
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    read();
    solve();

    return 0;
}
