//Code by Patcas Csaba
//Time complexity: O(n^3)
//Space complexity: O(n * m)
//Method: Gauss-Jordan (merge prea lent)
//Working time: 1 hour

#include <stdio.h>
#include <ctype.h>
#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <iostream> 
#include <sstream> 
#include <numeric> 
#include <algorithm> 
#include <cmath> 
#include <queue> 
#include <bitset> 
#include <time.h>
#include <assert.h>

using namespace std;

#define in_file "color.in"
#define out_file "color.out"

#define VI vector <int>
#define VB vector <bool>
#define FORN(i,n) for(int i=0;i<n;++i)
#define FOR(i,a,b) for(int i=a;i<=b;++i)
#define S size()
#define B begin() 
#define E end() 
#define X first
#define RS resize
#define Y second
#define PB push_back
#define MP make_pair
#define ALL(x) x.begin(),x.end()
#define repeat do{ 
#define until(x) }while(!(x)); 

#define base 666013

FILE* fin=fopen(in_file,"r");
FILE* fout=fopen(out_file,"w");
int n, m, k, c, allK;
VI a, sol;
vector <VI> b, oldB;
VB used;

inline int Mod(int x)
{
	while (x<0) x+=k;
	return x%k;
}

void euclid(int a, int b, int *d, int *x, int *y)
{
    if (b == 0) {
        *d = a;
        *x = 1;
        *y = 0;
    } else {
        int x0, y0;
        euclid(b, a % b, d, &x0, &y0);
        *x = y0;
        *y = x0 - (a / b) * y0;
    }
}

int InvMod(int x)
{
	int gcd, aa, bb;
	euclid(x, k, &gcd, &aa, &bb);
	aa=Mod(aa);
	assert(((x * aa) % k) == 1);
	return aa;
}

int GaussJordan()
{
	FOR(i,1,n)
		FOR(j,1,m) b[i][j]=Mod(b[i][j]);
	sol.RS(n+1);
	FOR(i,1,n) sol[i]=Mod(c-a[i]);
	int ans=0;
	used.RS(n+1);
	fill(ALL(used),false);
	FOR(j,1,m)
	{
		bool found=false;
		FOR(i,1,n)
			if (!used[i] && b[i][j])
			{
				found=true;
				used[i]=true;
				int invMod=InvMod(b[i][j]);
				FOR(k,1,n)
					if (k!=i && b[k][j])
					{
						int ratio=b[k][j] * invMod;
						FOR(q,1,m) 
							b[k][q]=Mod(b[k][q] - ratio * b[i][q]);
						sol[k]=Mod(sol[k] - ratio * sol[i]);
					}
				break;
			}
		if (!found) ++ans;
	}
	return ans;
}

int main()
{
	fscanf(fin,"%d%d%d%d",&n,&m,&k,&c);
	a.RS(n+1);
	FOR(i,1,n) fscanf(fin,"%d",&a[i]);
	b.RS(n+1,VI(m+1));
	FOR(i,1,m)
		FOR(j,1,n) fscanf(fin,"%d",&b[j][i]);
	fclose(fin);

	allK=k;
	oldB=b;
	long long solution=1;

	for(int i=2;i*i<=allK;++i)
	{
		if (allK%i) continue;
		k=i;
		b=oldB;
		int freeVar=GaussJordan();
		FORN(i,freeVar) solution=(solution * k) % base;
		allK/=i;
	}
	if (allK>1)
	{
		k=allK;
		b=oldB;
		int freeVar=GaussJordan();
		FORN(i,freeVar) solution=(solution * k) % base;
	}
	
	fprintf(fout,"%d",solution);
	fclose(fout);

	return 0;
}