//Code by Patcas Csaba
//Time complexity: O(n log n)
//Space complexity: O(n)
//Method: AI

#include <stdio.h>
#include <ctype.h>
#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <iostream> 
#include <sstream> 
#include <numeric> 
#include <algorithm> 
#include <cmath> 
#include <queue> 
#include <bitset> 
#include <time.h>
#include <assert.h>

using namespace std;

#define in_file "sir.in"
#define out_file "sir.out"

#define VI vector <int>
#define FORN(i,n) for(int i=0;i<n;++i)
#define FOR(i,a,b) for(int i=a;i<=b;++i)
#define S size()
#define B begin() 
#define E end() 
#define X first
#define RS resize
#define Y second
#define PB push_back
#define MP make_pair
#define ALL(x) x.begin(),x.end()
#define repeat do{ 
#define until(x) }while(!(x)); 

#define left (node<<1)
#define right (node<<1|1)
#define mid ((down + up) / 2)

int n, s, solution, solD, solU;
VI a, match, aiMin, aiMax;
vector <bool> aiGood;

void build(int node, int down, int up)
{
	if (down == up)
	{
		aiMin[node]=match[down];
		aiMax[node]=match[down];
		aiGood[node]=match[down]!=0;
		return;
	}
	build(left,down,mid);
	build(right,mid+1,up);
	aiMin[node]=min(aiMin[left],aiMin[right]);
	aiMax[node]=max(aiMax[left],aiMax[right]);
	aiGood[node]=aiGood[left]&aiGood[right];
}

int queryMin(int node, int down, int up, int d, int u)
{
	if (d<=down && up<=u) return aiMin[node];
	int ans=2000000001;
	if (d<=mid) ans=queryMin(left,down,mid,d,u);
	if ((mid+1)<=u) ans=min(ans,queryMin(right,mid+1,up,d,u));
	return ans;
}

int queryMax(int node, int down, int up, int d, int u)
{
	if (d<=down && up<=u) return aiMax[node];
	int ans=0;
	if (d<=mid) ans=queryMax(left,down,mid,d,u);
	if ((mid+1)<=u) ans=min(ans,queryMax(right,mid+1,up,d,u));
	return ans;
}

int queryGood(int node, int down, int up, int d, int u)
{
	if (d<=down && up<=u) return aiGood[node];
	bool ans=true;
	if (d<=mid) ans=queryGood(left,down,mid,d,u);
	if ((mid+1)<=u) ans&=queryGood(right,mid+1,up,d,u);
	return ans;
}

void solve()
{
	set <pair <int, int> > poz;
	FOR(i,1,n) poz.insert(MP(a[i],i));
	match.RS(n+1);
	FOR(i,1,n)
	{
		pair <int, int> aux= *poz.lower_bound(MP(s-a[i],0));
		if (aux.X == s - a[i]) match[i]=aux.Y;
	}
	int pow2;
	for(pow2=1;pow2<=n;pow2<<=1) ;
	pow2=pow2<<1|1;
	aiMin.RS(pow2);
	aiMax.RS(pow2);
	aiGood.RS(pow2);
	build(1,1,n);

	solution=0;
	FOR(i,1,n)
		if (match[i])
		{
			int iMin=min(i,match[i]);
			int iMax=max(i,match[i]);
			if (!queryGood(1,1,n,iMin,iMax)) continue;
			if (queryMin(1,1,n,iMin,iMax)<iMin) continue;
			if (aux=queryMax(1,1,n,iMin,iMax)>iMax) continue;
			if (solution<iMax-iMin+1)
			{
				solution=iMax-iMin+1;
				solD=iMin;
				solU=iMax;
			}
		}
}

int main()
{
	FILE* fin=fopen(in_file,"r");
	fscanf(fin,"%d%d",&n,&s);
	a.RS(n+1);
	FOR(i,1,n) fscanf(fin,"%d",&a[i]);
	fclose(fin);

	solve();

	FILE* fout=fopen(out_file,"w");
	fprintf(fout,"%d %d %d",solution,solD,solU);
	fclose(fout);

	return 0;
}