/*
Autor: Victor Rusu
Punctaj: 100
*/
#include <cstdio>
#include <cstring>
#include <vector>
#include <queue>

using namespace std;

#define FIN "politia.in"
#define FOUT "politia.out"

#define MAX_N 256

int NA, NB, NE1, NE2, NE3;
int ADD1, ADD2, ADD3, ADD4, ADD5, ADD6;
vector<int> G[10 * MAX_N];
int cap[10 * MAX_N][10 * MAX_N];
int viz[10 * MAX_N];
int tata[10 * MAX_N];
queue<int> Q;
int dest;

void read() {
    scanf("%d %d %d %d %d", &NA, &NB, &NE1, &NE2, &NE3);
    
    ADD1 = 0;
    ADD2 = 2 * NE1;
    ADD3 = ADD2 + 2 * NA;
    ADD4 = ADD3 + 2 * NE2;
    ADD5 = ADD4 + 2 * NB;
    ADD6 = ADD5 + 2 * NE3;

    for (int i = 1; i <= NA; ++i) {
        int K, v;
        scanf("%d", &K);
        for (int j = 1; j <= K; ++j) {
            scanf("%d", &v);
            G[ADD2 + i].push_back(ADD1 + NE1 + v);
            G[ADD1 + NE1 + v].push_back(ADD2 + i);
            cap[ADD1 + NE1 + v][ADD2 + i] = 1;
        }
        scanf("%d", &K);
        for (int j = 1; j <= K; ++j) {
            scanf("%d", &v);
            G[ADD2 + NA + i].push_back(ADD3 + v);
            G[ADD3 + v].push_back(ADD2 + NA + i);
            cap[ADD2 + NA + i][ADD3 + v] = 1;
        }
    }
    for (int i = 1; i <= NB; ++i) {
        int K, v;
        scanf("%d", &K);
        for (int j = 1; j <= K; ++j) {
            scanf("%d", &v);
            G[ADD3 + NE2 + v].push_back(ADD4 + i);
            G[ADD4 + i].push_back(ADD3 + NE2 + v);
            cap[ADD3 + NE2 + v][ADD4 + i] = 1;
        }
        scanf("%d", &K);
        for (int j = 1; j <= K; ++j) {
            scanf("%d", &v);
            G[ADD4 + NB + i].push_back(ADD5 + v);
            G[ADD5 + v].push_back(ADD4 + NB + i);
            cap[ADD4 + NB + i][ADD5 + v] = 1;
        }
    }
}

int BF() {
    while (!Q.empty()) Q.pop();
    Q.push(0);
    memset(viz, 0, sizeof(viz));
    viz[0] = 1;

    while (!Q.empty()) {
        int nod = Q.front();
        Q.pop();
        if (nod == dest)
            return 1;

        for (int i = 0; i < (int)G[nod].size(); ++i)
            if (!viz[G[nod][i]] && cap[nod][G[nod][i]] > 0) {
                tata[G[nod][i]] = nod;
                viz[G[nod][i]] = 1;
                Q.push(G[nod][i]);
            }
    }

    return 0;
}

void solve() {
    for (int i = 1; i <= NE1; ++i) {
        G[0].push_back(i);
        G[i].push_back(0);
        cap[0][i] = 1;

        G[i].push_back(NE1 + i);
        G[NE1 + i].push_back(i);
        cap[i][NE1 + i] = 1;
    }

    for (int i = 1; i <= NA; ++i) {
        G[ADD2 + i].push_back(ADD2 + NA + i);
        G[ADD2 + NA + i].push_back(ADD2 + i);
        cap[ADD2 + i][ADD2 + NA + i] = 1;
    }

    for (int i = 1; i <= NE2; ++i) {
        G[ADD3 + i].push_back(ADD3 + NE2 + i);
        G[ADD3 + NE2 + i].push_back(ADD3 + i);
        cap[ADD3 + i][ADD3 + NE2 + i] = 1;
    }
    
    for (int i = 1; i <= NB; ++i) {
        G[ADD4 + i].push_back(ADD4 + NB + i);
        G[ADD4 + NB + i].push_back(ADD4 + i);
        cap[ADD4 + i][ADD4 + NB + i] = 1;
    }

    for (int i = 1; i <= NE3; ++i) {
        G[ADD5 + i].push_back(ADD5 + NE3 + i);
        G[ADD5 + NE3 + i].push_back(ADD5 + i);
        cap[ADD5 + i][ADD5 + NE3 + i] = 1;

        G[ADD5 + NE3 + i].push_back(ADD6 + 1);
        G[ADD6 + 1].push_back(ADD5 + NE3 + i);
        cap[ADD5 + NE3 + i][ADD6 + 1] = 1;
    }

    dest = ADD6 + 1;
    int flux = 0;
    while (BF())
        for (int i = 1; i < dest; ++i)
            if (viz[i] && cap[i][dest] > 0) {
                int add = cap[i][dest];
                for (int nod = i; nod != 0; nod = tata[nod])
                    add = min(add, cap[tata[nod]][nod]);
                if (!add) continue;
                flux += add;
                --cap[i][dest], ++cap[dest][i];
                for (int nod = i; nod != 0; nod = tata[nod]) {
                    --cap[tata[nod]][nod];
                    ++cap[nod][tata[nod]];
                }
            }

    printf("%d\n", flux);
}

int main() {
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    read();
    solve();

    return 0;
}
