// Autor: Stefan-Alexandru Filip
// solutie 100 pct
#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>
#include <cstring>
#include <cassert>

using namespace std;

const int NMAX = 200;
const int GMAX = 256;
const int VMAX = 2048;
const int INF = 0x3f3f3f3f;

int N, M, NE1, NE2, NE3, S, D, R2, R3, R4, R5;
int T[VMAX], maxflow;
char C[VMAX][VMAX], F[VMAX][VMAX];
vector <int> G[VMAX];

void add(int u, int v) {
	G[u].push_back(v);
	G[v].push_back(u);
	C[u][v] = 1;
}

void read(void) {
	ifstream fin("politia.in");
	int i, j, l1, l2, u;

	assert( fin >> N >> M >> NE1 >> NE2 >> NE3 );
	assert(1 <= N && N <= NMAX);
	assert(1 <= M && M <= NMAX);
	assert(1 <= NE1 && NE1 <= NMAX);
	assert(1 <= NE2 && NE2 <= NMAX);
	assert(1 <= NE3 && NE3 <= NMAX);

	S = 0;
	R2 = NE1 + NE1;
	R3 = R2 + N + N;
	R4 = R3 + NE2 + NE2;
	R5 = R4 + M + M;
	D = R5 + NE3 + NE3 + 1;

//	printf("%d %d %d %d %d\n", R2, R3, R4, R5, D);

	for (i = 1; i <= NE1; ++i) {
		add(0, i);
		add(i, NE1 + i);
	}

	for (i = 1; i <= N; ++i) add(R2 + i, R2 + N + i);
	for (i = 1; i <= NE2; ++i) add(R3 + i, R3 + NE2 + i);
	for (i = 1; i <= M; ++i) add(R4 + i, R4 + M + i);
	
	for (i = 1; i <= NE3; ++i) {
		add(R5 + i, R5 + NE3 + i);
		add(R5 + NE3 + i, D);
	}

	for (i = 1; i <= N; ++i) {
		assert( fin >> l1 );
		
		for (j = 0; j < l1; ++j)
			assert( fin >> u ), add(NE1 + u, R2 + i);

		assert( fin >> l2 );

		for (j = 0; j < l2; ++j)
			assert( fin >> u ), add(R2 + N + i, R3 + u);
	}

	for (i = 1; i <= M; ++i) {
		assert( fin >> l1 );

		for (j = 0; j < l1; ++j)
			assert( fin >> u ), add(R3 + NE2 + u, R4 + i);

		assert( fin >> l2 );

		for (j = 0; j < l2; ++j)
			assert( fin >> u ), add(R4 + M + i, R5 + u);
	}
/*
	for (i = 0; i <= D; ++i) {
		printf("nodul %d: ", i);
		for (j = 0; j < G[i].size(); ++j)
			printf("%d(%d) ", G[i][j], C[i][ G[i][j] ]);
		printf("\n");
	}
*/
	fin.close();
}

bool BFS(void) {
	queue <int> Q;
	vector <int> :: iterator p;
	int u;

	memset(T, 0xff, sizeof(T));
	T[S] = 0;
	for (Q.push(0); !Q.empty(); Q.pop()) {
		for (p = G[u = Q.front()].begin(); p != G[u].end(); ++p) {
			if (T[*p] != -1 || C[u][*p] <= F[u][*p]) continue;
			Q.push(*p); T[*p] = u;
			if (*p == D) return true;
		}
	}

	return false;
}

void edmondkarp(void) {
	int u, v, flow;

	while ( BFS() ) {
		flow = INF;
		for (u = T[ v = D]; u > 0; u = T[ v = u ])
			flow = min( flow, C[u][v] - F[u][v] );

		maxflow += flow;

		for (u = T[ v = D ]; u > 0; u = T[ v = u ])
			F[u][v] += flow, F[v][u] -= flow;
	}
}

void write(void) {
	ofstream fout("politia.out");

	fout << maxflow << '\n';

	fout.close();
}

int main(void) {

	read();

	edmondkarp();

	write();

	return 0;
}
