// Autor: Marius Stroe
// solutie 60 pct
#include <cstdio>
#include <cassert>
#include <memory.h>
#include <algorithm>
using namespace std;

const char iname[] = "politia.in";
const char oname[] = "politia.out";

#define MAXN  5000

#define sofer(i)    (i)
#define itist(i)    (S + (i))
#define masina(i)   (S + I + (i))
#define radio(i)    (S + I + M + (i))
#define computer(i) (S + I + M + R + (i))
#define in(i)  (2 * (i))
#define out(i) (2 * (i) + 1)
#define FOR(i, a, b)  for (int i = (a); i <= (b); ++ i)

struct list {
    int varf, cap, flux;
    list *nxt, *dup;
};

typedef list* plist;

plist adj[MAXN], edge[MAXN];    int sel[MAXN], que[MAXN];


void insert(plist& nou, plist& dup, int x, int y)
{
    nou = new list, dup = new list;
    nou->varf = y, dup->varf = x;
    nou->dup = dup, dup->dup = nou;
    nou->nxt = adj[x], dup->nxt = adj[y];
    adj[x] = nou, adj[y] = dup;
    nou->cap = 1, nou->flux = 0;
    dup->cap = 0, dup->flux = 0;
}

int BFS(const int src, const int sink)
{
    int h, t;
    plist it;

    edge[src] = 0;
    memset(sel, 0, sizeof(sel));
    for (sel[que[h = t = 0] = src] = 1; h <= t; ++ h)
    {
        for (it = adj[que[h]]; it; it = it->nxt)
            if (it->cap - it->flux > 0 && !sel[it->varf])
            {
                sel[que[++ t] = it->varf] = 1;
                edge[it->varf] = it;
                if (it->varf == sink)
                {
                    for (it = edge[sink]; it; it = edge[it->dup->varf])
                        it->flux ++, it->dup->flux --;
                        return 1;
                }
            }
    }
    return 0;
}

int main(void)
{
    FILE *fi = fopen(iname, "r");
    int S, I, M, R, C;

    int sink = MAXN, src = 0;

    plist nou, dup;

    assert( fscanf(fi, "%d %d %d %d %d", &S, &I, &M, &R, &C) == 5 );
    // dublez nodurile soferilor
    FOR (i, 1, S)
        insert(nou, dup, in(sofer(i)), out(sofer(i)));
    // datele soferilor
    FOR (i, 1, S) {
        int n, m, r;
        // masinile soferului i
        assert( fscanf(fi, "%d", &n) == 1 );
        FOR (j, 1, n) {
            assert( fscanf(fi, "%d", &m) == 1 );
            insert(nou, dup, out(sofer(i)), in(masina(m)));
        }
        // radioul soferului i
        assert( fscanf(fi, "%d", &n) == 1 );
        FOR (j, 1, n) {
            assert( fscanf(fi, "%d", &r) == 1 );
            insert(nou, dup, out(radio(r)), in(sofer(i)));
        }
    }

    // dublez nodurile itistilor
    FOR (i, 1, I)
        insert(nou, dup, in(itist(i)), out(itist(i)));
    FOR (i, 1, I) {
        int n, r, c;
        // radiourile itistului i
        assert( fscanf(fi, "%d", &n) == 1 );
        FOR (j, 1, n) {
            assert( fscanf(fi, "%d", &r) == 1 );
            insert(nou, dup, out(itist(i)), in(radio(r)));
        }
        // computerele itistului i
        assert( fscanf(fi, "%d", &n) == 1 );
        FOR (j, 1, n) {
            assert( fscanf(fi, "%d", &c) == 1 );
            insert(nou, dup, out(computer(c)), in(itist(i)));
        }
    }

    // dublez nodurile computerelor, radiourilor, masinilor
    FOR (i, 1, C)
        insert(nou, dup, in(computer(i)), out(computer(i)));
    FOR (i, 1, R)
        insert(nou, dup, in(radio(i)), out(radio(i)));
    FOR (i, 1, M)
        insert(nou, dup, in(masina(i)), out(masina(i)));

    // muchiile din sursa in computere
    FOR (i, 1, C)
        insert(nou, dup, src, in(computer(i)));
    // muchiile din masini in destinatie
    FOR (i, 1, M)
        insert(nou, dup, out(masina(i)), sink);

    int res = 0;
    while (BFS(src, sink))   res ++;

    fprintf(fopen(oname, "w"), "%d\n", res);

    fclose(fi);
    return 0;
}
