// Sir 
// O(n log^2 n)
// (c) Mircea Dima
#include <cstdio>
#include <algorithm>
#include <string>
#include <cstdlib>
#define maxn 200001
#define maxh 666013
#define common \
    int m=(l+r)>>1, L=n<<1, R=L|1
#define pb push_back
#define ui int

using namespace std;

struct point { ui x, y; point(){}; point(ui a, ui b){x=a; y=b;};};
struct cmp{ 
	bool operator()(const point &a, const point &b)const
	{
		if(a.x<b.x) return 1;
		//if(a.x==b.x && a.y<b.y) return 1;
		return 0;
	}
};

point A[maxn];
ui X1, X2;
int *H[maxn*3];
int len[maxn*3];
ui N, M;
ui x1, y1, x2, y2;



void build(ui n, ui l, ui r)
{
	if(l==r)
	{
	    H[n] = new int[3];
	    H[n][len[n]++] = A[l].y;
	    return;
	}

	common;

	build(L, l, m);
	build(R, m+1, r);


	int i,j, N=len[L], M=len[R];
	
	H[n]=new int[N+M+1];

	for(i=0, j=0; i < N && j < M; )
		if(H[L][i] > H[R][j])  H[n][len[n]++]=H[R][j], ++j;
		else H[n][len[n]++]=H[L][i],++i;
	

	for(;j<M;++j) H[n][len[n]++]=H[R][j];
	for(;i<N;++i) H[n][len[n]++]=H[L][i];
	
}

inline ui bsearch(int a[],int n, ui l, ui r)
{
	if(n==1) 
	    if(a[0] >= y1 && a[0] <= y2) return 1;
		else return 0;

	ui i, cnt, pi=0, pj=0;
	
	for(i=0, cnt=(1<<17); cnt ;cnt>>=1)
		if(i +cnt < n)
			if(a[i + cnt] <= y2) i += cnt;
	pj=i;
	
	for(i=n-1, cnt=(1<<17); cnt ;cnt>>=1)
		if(i - cnt >= 0)
			if(a[i - cnt] >= y1) i -= cnt;
	pi=i;
	
	return pj-pi+1;
}

inline ui query(ui n, ui l, ui r)// x1, x2, y1, y2
{
	if(x1 <= l && r <= x2)
	{
    	    if (y2 < H[n][0] || y1 > H[n][len[n]-1]) return 0;
	    if (y1 <= H[n][0] && H[n][len[n]-1] <= y2) return (r - l + 1);
	    return bsearch(H[n],len[n], l, r); 
	}

	common;

	ui s=0;
	
	if(x1 <= m) s += query(L, l, m);
	if(x2 > m) s += query(R, m+1, r);
	
	return s;
}


int a[maxn];
int n,S;

void read()
{
    freopen("sir.in","r",stdin);
    scanf("%d %d\n", &n, &S);
    N=n;
    for(int i=1; i <= n; ++i) scanf("%d ", a+i);
}

struct nod
{
    int x;
    int pz;
    nod *n;
};

nod *Hsh[maxh];

inline void add(int v, int pz)
{
    int h=v%maxh;
    
    for(nod *i=Hsh[h]; i; i=i->n)
	if(i->x == v)
	{
	    i->pz=pz;
	    return;
	}

    nod *p=new nod;
    p->n=Hsh[h];
    p->x=v;
    p->pz=pz;
    Hsh[h]=p;
}


int next[maxn];
int nr_zero[maxn];


void init()
{
    int i,h,ok;
    nod *p;

    for(i=n; i ; --i)
    {
	
	if(S-a[i] < 0)
	{
	    next[i]=-1;
	    add(a[i],i);
	    continue;
	}
	h=(S-a[i])%maxh;

	ok=1;

	for(p=Hsh[h]; p; p=p->n)
	    if(p->x == (S-a[i]))
	    {
		
		next[i]=p->pz;
		
		ok=0;
	    }

	if(ok)   next[i]=-1;
	 
	add(a[i],i);
    }


    nr_zero[0]=0;

    for(i=1; i <= n; ++i)
	if(next[i] == -1) nr_zero[i]=nr_zero[i-1] + 1;
	    else nr_zero[i]=nr_zero[i-1];

    N=0;

    for(i=1; i <= n; ++i) 
	if(next[i] != -1)
	    A[++N] = point(i, next[i]);

	sort(A+1, A+N+1, cmp());

	build(1,1,N);


//	for(i=1; i <= n; ++i)
//	    printf("%d %d\n", A[i].x, A[i].y);
}


void solve()
{

    int i, j,cnt,ii;
    int smin=0x3f3f3f3f;
    int s;

    int lenmax=0,first=-1,last=-1;

    for(ii=1; ii <= n; ++ii)
	if(next[ii] != -1 && (next[ii]-ii)%2 )
	{
	    
	    x1=ii;
	    x2=next[ii];
	    y1=ii;
	    y2=next[ii];

	    if(x2 < A[1].x || x1 > A[N].x)  s=0;
	    else
	    {

		for(i=1, cnt=(1<<17); cnt; cnt>>=1)
		    if(i + cnt <= n)
			if(A[i + cnt].x <= x2) i += cnt;

		x2 = i;

		for(i=N, cnt=(1<<17); cnt; cnt>>=1)
		    if(i - cnt >= 1)
			if(A[i - cnt].x >= x1) i -= cnt;

		x1 = i;
		
		s=query(1,1,N);


	    }

	    int v=(next[ii]-ii+1)/2;

	    if(v == s)
	    {
		if(lenmax < next[ii]-ii+1) 
		    lenmax=next[ii]-ii+1, 
		    first=ii,
		    last=next[ii];
		    

			//optimizare
		    ii=next[ii]-1;
		//printf("ha %d %d %d\n", ii, next[ii],s);
	    }
	}


	freopen("sir.out","w",stdout);
	
    printf("%d %d %d\n", lenmax, first,last);



}

int main()
{
    read();
    init();
   
    solve(); 
    return 0;
}

