// Autor: Stefan-Alexandru Filip
// solutie 100 pct
#include <fstream>
#include <map>
#include <algorithm>

using namespace std;

typedef pair <int, int> PII;

#define MP make_pair

const int NMAX = 1 << 18;
const int INF = 0x3f3f3f3f;

int N, S, A[NMAX], other[NMAX], a, b;
PII AI[NMAX << 1];
map <int, int> M;

void build(int i, int st, int dr) {
	if (st == dr) {
		AI[i] = MP(other[st], other[dr]);
		return;
	}

	int mij = (st + dr) >> 1;
	int is = i << 1;

	build(is, st, mij);
	build(is|1, mij+1, dr);

	AI[i] = MP( min(AI[is].first, AI[is|1].first), max(AI[is].second, AI[is|1].second) );
}

PII query(int i, int st, int dr) {
	if (a <= st && dr <= b)
		return AI[i];
	
	int mij = (st + dr) >> 1;
	int is = i << 1;
	PII R(INF, 0), aux;

	if (a <= mij)
		R = query(is, st, mij);
	if (mij < b) {
		aux = query(is|1, mij+1, dr);
		R.first = min(R.first, aux.first);
		R.second = max(R.second, aux.second);
	}

	return R;
}

int main(void) {
	ifstream fin("sir.in");
	ofstream fout("sir.out");
	int i, sol = 0, solb = -1, sole = -1;
	PII q;
	map<int, int> :: iterator it;

	fin >> N >> S;

	for (i = 1; i <= N; ++i)
		fin >> A[i], M[ A[i] ] = i;

	for (i = 1; i <= N; ++i)
		other[i] = (it = M.find(S - A[i])) == M.end() ? INF : it->second;

	build(1, 1, N);

	for (i = 1; i <= N; ++i) {
		if (other[i] > i) continue;
		a = other[i], b = i;
		q = query(1, 1, N);

		if (other[i] <= q.first && q.second <= i && sol < i - other[i] + 1) {
			sol = i - other[i] + 1;
			solb = other[i];
			sole = i;
		}
	}

	fout << sol << ' ' << solb << ' ' << sole << '\n';

	fin.close();

	return 0;
}
