/*
    Sir
    Autor: Marius Stroe
    Complexitate: O(N^2)
*/

#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;

const char iname[] = "sir.in";
const char oname[] = "sir.out";

const int MAXN = 250005;

#define FOR(i, a, b)  for (int i = (a); i <= (b); ++ i)
#define left(n)  ((n) << 1)
#define right(n) (left(n) + 1)
#define INF  2000000000

int V[MAXN], other[MAXN], bad[MAXN], n, sum;

map <int, int> M;


pair <int, int> getBrute(void)
{
    int length = 0, first;

    for (int i = 1; i <= n; ) {
        if (bad[i] == 0 && i < other[i]) {
            int a = i, b = other[i];
            int j;
            for (j = a; j <= b; ) {
                if (other[j] < a || other[j] > b)
                    break ;
                j ++;
            }
            if (j == b + 1) {
                if (length < j-i || (length == j-i && i < first))
                    length = j-i, first = i;
                i = b + 1;
            }
            else
                i ++;
        }
        else
            i ++;
    }
    return make_pair(length, first);
}

int main(void)
{
    FILE *fi = fopen(iname, "r");
    FILE *fo = fopen(oname, "w");

    assert( fscanf(fi, "%d %d", &n, &sum) == 2 );
    FOR (i, 1, n)
        assert( fscanf(fi, "%d", &V[i]) == 1 );

    fclose(fi);

    FOR (i, 1, n)  M[ V[i] ] = i;
    FOR (i, 1, n) {
        map <int, int>::iterator it = M.find(sum - V[i]);

        if (it != M.end() && (*it).second != i)
            other[i] = (*it).second;
        else
            bad[i] = 1;
    }

    pair <int, int> resb = getBrute();
    fprintf(fo, "%d %d %d\n", resb.first, resb.second, resb.second + resb.first - 1);

    fclose(fo);
    return 0;
}
